﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Windows.Forms;

namespace X0
{
    public partial class Form1 : Form
    {
        int jucator;
        int[,] A;

        public Form1()
        {
            InitializeComponent();
        }

        private void Form1_Shown(object sender, EventArgs e)
        {
            jucator = 1;
            A = new int[3, 3];
            foreach (Control x in this.Controls)
                x.BackColor = Color.White;
        }

        int castigator()
        {
            int p1 = A[0, 0] * A[0, 1] * A[0, 2];
            int p2 = A[1, 0] * A[1, 1] * A[1, 2];
            int p3 = A[2, 0] * A[2, 1] * A[2, 2];
            int p4 = A[0, 0] * A[1, 0] * A[2, 0];
            int p5 = A[0, 1] * A[1, 1] * A[2, 1];
            int p6 = A[0, 2] * A[1, 2] * A[2, 2];
            int p7 = A[0, 0] * A[1, 1] * A[2, 2];
            int p8 = A[0, 2] * A[1, 1] * A[2, 0];
            if (p1 == 1 || p2 == 1 || p3 == 1 || p4 == 1 ||
               p5 == 1 || p6 == 1 || p7 == 1 || p8 == 1)
                return 1;
            else if (p1 == 8 || p2 == 8 || p3 == 8 || p4 == 8 ||
               p5 == 8 || p6 == 8 || p7 == 8 || p8 == 8)
                return 2;
            else if (p1 !=0 && p2 != 0 && p3 != 0 && p4 != 0 ||
               p5 != 0 && p6 != 0 && p7 != 0 && p8 != 0)
                return 3;
            else return 0;
        }

        void deseneaza()
        {
            int p1 = A[0, 0] * A[0, 1] * A[0, 2];
            int p2 = A[1, 0] * A[1, 1] * A[1, 2];
            int p3 = A[2, 0] * A[2, 1] * A[2, 2];
            int p4 = A[0, 0] * A[1, 0] * A[2, 0];
            int p5 = A[0, 1] * A[1, 1] * A[2, 1];
            int p6 = A[0, 2] * A[1, 2] * A[2, 2];
            int p7 = A[0, 0] * A[1, 1] * A[2, 2];
            int p8 = A[0, 2] * A[1, 1] * A[2, 0];
            if (p1 == 1 || p1==8)
                button1.BackColor = button2.BackColor = button3.BackColor = Color.Red;
            if (p2 == 1 || p2 == 8)
                button4.BackColor = button5.BackColor = button6.BackColor = Color.Red;
            if (p3 == 1 || p3 == 8)
                button7.BackColor = button8.BackColor = button9.BackColor = Color.Red;
            if (p4 == 1 || p4 == 8)
                button1.BackColor = button4.BackColor = button7.BackColor = Color.Red;
            if (p5 == 1 || p5 == 8)
                button2.BackColor = button5.BackColor = button8.BackColor = Color.Red;
            if (p6 == 1 || p6 == 8)
                button3.BackColor = button6.BackColor = button9.BackColor = Color.Red;
            if (p7 == 1 || p7 == 8)
                button1.BackColor = button5.BackColor = button9.BackColor = Color.Red;
            if (p8 == 1 || p8 == 8)
                button3.BackColor = button5.BackColor = button7.BackColor = Color.Red;
        }

        void termina()
        {
            foreach (Control x in this.Controls)
                x.Enabled = false;
            deseneaza();
            if(jucator==1) MessageBox.Show("A cartigat X");
            else if(jucator==2) MessageBox.Show("A cartigat O");
            else MessageBox.Show("Egalitate");
            foreach (Control x in this.Controls)
            {
                x.Text = "";
                x.Enabled = true;
                x.BackColor = Color.White;
            }
            A = new int[3, 3];
            jucator = 2;
        }

        void click(int i, int j, Button b)
        {
            if (jucator == 1)
            {
                b.Text = "X";
                A[i, j] = 1;
            }
            else
            {
                b.Text = "O";
                A[i, j] = 2;
            }
            b.Enabled = false;
            if (castigator() != 0)
            {
                if (castigator() == 3)
                    jucator = 3;
                termina();
            }
            jucator = 3 - jucator;
        }

        private void button1_Click(object sender, EventArgs e)
        {
            click(0, 0, button1);
        }

        private void button2_Click(object sender, EventArgs e)
        {
            click(0, 1, button2);
        }

        private void button3_Click(object sender, EventArgs e)
        {
            click(0, 2, button3);
        }

        private void button4_Click(object sender, EventArgs e)
        {
            click(1, 0, button4);
        }

        private void button5_Click(object sender, EventArgs e)
        {
            click(1, 1, button5);
        }

        private void button6_Click(object sender, EventArgs e)
        {
            click(1, 2, button6);
        }

        private void button7_Click(object sender, EventArgs e)
        {
            click(2, 0, button7);
        }

        private void button8_Click(object sender, EventArgs e)
        {
            click(2, 1, button8);
        }

        private void button9_Click(object sender, EventArgs e)
        {
            click(2, 2, button9);
        }
    }
}
